function [Hw,Hwx,lambda,W,X,Y,exp_xy] = init2drgpe(N,NH,h,d,c,gamma,potential,m,omega) 
indx = 0;
indy = 0;
delta = sqrt(2);
% Gauss--Hermite quadrature nodes and (fourth root of) weights relative to the 
% weight w(x) = exp(-(delta*gamma*x)^2).
ab = r_hermite(2*NH(1)-1);
[xw] = gauss(2*NH(1)-1,ab);
x = xw(:,1)/delta/gamma(1);
%[dummy,idx] = sort(abs(x),'descend');
%x = x(idx);
wx = (xw(:,2)/delta/gamma(1)).^0.25;
%wx = wx(idx);
Wx = spdiags(wx,0,2*NH(1)-1,2*NH(1)-1);
ab = r_hermite(2*NH(2)-1);
[yw] = gauss(2*NH(2)-1,ab);
y = yw(:,1)/delta/gamma(2);
%[dummy,idy] = sort(abs(y),'descend');
%y = y(idy);
wy = (yw(:,2)/delta/gamma(2)).^0.25;
%wy = wy(idy);
Wy = spdiags(wy,0,2*NH(2)-1,2*NH(2)-1);
[X,Y] = meshgrid(x,y);
% Hermite polynomials orthonormal with respect to the weight w(x/delta),
% times the weights
[Hw{1},Hwx{1}] = hermatw(x,NH(1),gamma(1),wx');
[Hw{2},Hwx{2}] = hermatw(y,NH(2),gamma(2),wy');
% Common eigenvalues relative to -d^2 / d x^2 + 1/2 (gamma^2*x)^2
[xev,yev] = meshgrid(2*[0:NH(1)-1],2*[0:NH(2)-1]);
lambda = d*((1+xev)*gamma(1)^2+(1+yev)*gamma(2)^2);
lambda = lambda(:);
exp_xy = (Wy*exp((gamma(1)^2*X.^2+gamma(2)^2*Y.^2)/2)*Wx).^2;
W = (feval(potential,X/sqrt(c),Y/sqrt(c),m,omega)/h-...
  d*((gamma(1)^2*X).^2+(gamma(2)^2*Y).^2)/2);
W = W.*exp_xy;
%iWx = spdiags(1./wx,0,2*NH(1)-1,2*NH(1)-1);
%iWy = spdiags(1./wy,0,2*NH(2)-1,2*NH(2)-1);
%exp_xy = iWy*exp(-1/2*gamma(1)^2*X.^2).*exp(-1/2*gamma(2)^2*Y.^2)*iWx;
