function [X,Y,W,exp_xy,lambda,Hw] = initialise_2d(M,gamma,potential,m,omega)
[x,w_x] = gauss_hermite_quadrature(M(1),gamma(1));
[y,w_y] = gauss_hermite_quadrature(M(2),gamma(2));
%exp_x = exp(-1/2*gamma(1)^2*x.^2);
%exp_y = exp(-1/2*gamma(2)^2*y.^2);
%for j = 1:length(y)
%    exp_xy(:,j) = exp_x*exp_y(j);
%end
[X,Y] = meshgrid(x,y);
Wx = spdiags(1./sqrt(w_x),0,M(1),M(1));
Wy = spdiags(1./sqrt(w_y),0,M(2),M(2));
exp_xy = Wy*exp(-1/2*gamma(1)^2*X.^2).*exp(-1/2*gamma(2)^2*Y.^2)*Wx;
%lambda_x = -sqrt(-1)*gamma(1)^2*(1/2 + [0:(M(1)-1)]');    
%lambda_y = -sqrt(-1)*gamma(2)^2*(1/2 + [0:(M(2)-1)]');   
[lambda_x,lambda_y] = meshgrid(gamma(1)^2*(1/2+[0:(M(1)-1)]'),...
gamma(2)^2*(1/2+ [0:(M(2)-1)]')); 
lambda = -sqrt(-1)*(lambda_x+lambda_y);
Hw{1} = hermatw(x,M(1),gamma(1),sqrt(w_x)');
Hw{2} = hermatw(y,M(2),gamma(2),sqrt(w_y)');
%i = [3,6];
%j = [3,5];
%sum(sum((Hw{2}(i(1),:)'*Hw{1}(i(2),:)).*(Hw{2}(j(1),:)'*Hw{1}(j(2),:))))
%H_x = hermite_polynomials(M(1),x,gamma(1));
%H_y = hermite_polynomials(M(2),y,gamma(2));
%Ht_x = H_x';
%Hw_x = H_x*diag(w_x);
%wHt_y = diag(w_y)*H_y';
W = feval(potential,X,Y,m,omega)-...
m*((gamma(1)^2*X).^2+(gamma(2)^2*Y).^2)/2;

