function [X,Y,W,exp_xy,lambda,Hw] = initialise_2d_sys(M,gamma,potential,m,omega)
global ii
% ii = 1 AND normalisation in partA --> imaginary time
ii = sqrt(-1);
l = length(potential);
[x,w_x] = gauss_hermite_quadrature(M(1),gamma(1));
[y,w_y] = gauss_hermite_quadrature(M(2),gamma(2));
%exp_x = exp(-1/2*gamma(1)^2*x.^2);
%exp_y = exp(-1/2*gamma(2)^2*y.^2);
%for j = 1:length(y)
%    exp_xy(:,j) = exp_x*exp_y(j);
%end
[X,Y] = meshgrid(x,y);
Wx = spdiags(1./sqrt(w_x),0,M(1),M(1));
Wy = spdiags(1./sqrt(w_y),0,M(2),M(2));
exp_xy = Wy*exp(-1/2*gamma(1)^2*X.^2).*exp(-1/2*gamma(2)^2*Y.^2)*Wx;
%lambda_x = -sqrt(-1)*gamma(1)^2*(1/2 + [0:(M(1)-1)]');    
%lambda_y = -sqrt(-1)*gamma(2)^2*(1/2 + [0:(M(2)-1)]');   
for i = 1:l
  [lambda_x,lambda_y] = meshgrid(gamma(1)^2*(1/2+[0:(M(1)-1)]'),...
  gamma(2)^2*(1/2+ [0:(M(2)-1)]')); 
  lambda{i} = -ii*(lambda_x+lambda_y);
  W{i} = feval(potential{i},X,Y,m(i),omega(i,:))-...
      m(i)*((gamma(1)^2*X).^2+(gamma(2)^2*Y).^2)/2;
end
Hw{1} = hermatw(x,M(1),gamma(1),sqrt(w_x)');
Hw{2} = hermatw(y,M(2),gamma(2),sqrt(w_y)');
%H_x = hermite_polynomials(M(1),x,gamma(1));
%H_y = hermite_polynomials(M(2),y,gamma(2));
%Ht_x = H_x';
%Hw_x = H_x*diag(w_x);
%wHt_y = diag(w_y)*H_y';

