function [dphis,initslope] = newton2dsys(NH,phis,phirw,contparams,Hw,ev,...
					 diffpotential,R,exact,Rpenalty,varargin)
% 2d systems
% search direction dphis and slope in search direction initslope
l = length(phis)-1;
% precompute squares
[phirw2{1:l}] = deal(zeros(size(phirw{1})));
for i = 1:l
  phirw2{i} = phirw{i}.^2;
end  
if (exist('Hwx2'))
else
  persistent Hwx2
  persistent Hwy2
  Hwx2 = Hw{1}.^2;
  Hwy2 = Hw{2}.^2;
end
if (exact == 1)
error('Exact Jacobian not implemented, yet')
if (nargin == 11)
  singtol = varagin{1};
else
  singtol = 1e-8;
end
  M(1) = size(Hw{1},2);
  M(2) = size(Hw{2},2);
  if (exist('K'))
  else
    persistent K
    K = kron(Hw{1}',Hw{2}');
  end  
for i = 1:l
  temp = 2*contparams{1}(i)*diffpotential{i}+6*contparams{2}(i,i)*phirw2{i};
  for j = 1:i-1
    temp = temp+2*contparams{2}(i,j)*phirw2{j};
  end  
  for j = i+1:l
    temp = temp+2*contparams{2}(i,j)*phirw2{j};
  end  
  temp = K'*spdiags(temp(:),0,M(1)*M(2),M(1)*M(2))*K;
  J{i} = temp+diag(ev{i}-2*phis{l+1}(i));
  temp = -[J{i},-2*phis{i};-2*phis{i}.' 0]\[R{i};R{l+1}];
end
else
if (nargin == 11)
  singtol = varagin{1};
else
  singtol = 1e-8;
end
% main diagonal of Hessian
[J{1:l}] = deal(zeros(NH(2)*NH(1),1));
for i = 1:l
  temp = 2*contparams{1}(i)*diffpotential{i}+6*contparams{2}(i,i)*phirw2{i};
  for j = 1:i-1
    temp = temp+2*contparams{2}(i,j)*phirw2{j};
%    if (exact == 2)
%    J{i,j} = Hwy2*(2*contparams{2}(i,j)*phirw{i}.*phirw{j})*Hwx2';
%    J{i,j} = J{i,j}(:);
%    else
%      J{i,j} = zeros(NH(2)*NH(1),1);
%    end
 end  
  for j = i+1:l
    temp = temp+2*contparams{2}(i,j)*phirw2{j};
%    if (exact == 2)
%    J{i,j} = Hwy2*(2*contparams{2}(i,j)*phirw{i}.*phirw{j})*Hwx2';
%    J{i,j} = J{i,j}(:);
%    else
%      J{i,j} = zeros(NH(2)*NH(1),1);
%    end
  end  
  temp = Hwy2*temp*Hwx2';
  tempJ = temp(:)+ev{i}-2*phis{l+1}(i);
  J{i} = tempJ*max(1,singtol*norm(R{i})/norm(tempJ));
  J{i}(J{i} == 0) = 1;
  J{i} = abs(J{i});
end
%temp = -optJinv2dsys(J,phis,R);
temp = -modJinv2dsys(J,phis,R);
end
initslope = Rpenalty'*temp(1:l*NH(2)*NH(1));
[dphis{1:l}] = deal(zeros(NH(2)*NH(1),1));
for i = 1:l
  dphis{i} = temp((i-1)*NH(2)*NH(1)+1:i*NH(2)*NH(1));
end  
dphis{l+1} = temp(l*NH(2)*NH(1)+(1:l));
