% plot at (xx,yy) the spectral function sum_i=0^N psi_j * H_j(xx) * exp (...
function [z varargout] = plothermite2d(xx,yy,psis,varargin)
if (nargin == 4)
  gamma = varargin{1};
  if (length(gamma) == 1)
    gamma = [gamma gamma];
  end 
else
  gamma = [1 1];								    
end
N = size(psis);
if (nargout >= 2)
   N = N+1;
end
Hx = ones(N(2),length(xx))*sqrt(gamma(1))/sqrt(sqrt(pi));
Hy = ones(N(1),length(yy))*sqrt(gamma(2))/sqrt(sqrt(pi));
Hx(1,:) = Hx(1,:).*exp(-(gamma(1)*xx(:)').^2/2);
Hy(1,:) = Hy(1,:).*exp(-(gamma(2)*yy(:)').^2/2);
sqrti = sqrt(2);
xxx = sqrti*gamma(1)*xx(:)';
yyy = sqrti*gamma(2)*yy(:)';
Hx(2,:) = sqrt(gamma(1)).*xxx/sqrt(sqrt(pi)).*exp(-(gamma(1)*xx(:)').^2/2);
Hy(2,:) = sqrt(gamma(2)).*yyy/sqrt(sqrt(pi)).*exp(-(gamma(2)*yy(:)').^2/2);
sqrti1 = 1;
minN = min(N(1),N(2));
for i = 3:minN
% the degree is i-1
  Hx(i,:) = (xxx.*Hx(i-1,:)-sqrti1*Hx(i-2,:))/sqrti;
  Hy(i,:) = (yyy.*Hy(i-1,:)-sqrti1*Hy(i-2,:))/sqrti;
  sqrti1 = sqrti;
  sqrti = sqrt(i);					    
end
if (N(1) > minN)
% degree in y
  for i = minN+1:N(1)
% the degree is i-1
    Hy(i,:) = (yyy.*Hy(i-1,:)-sqrti1*Hy(i-2,:))/sqrti;
    sqrti1 = sqrti;
    sqrti = sqrt(i);					    
  end
else
% degree in x
  for i = minN+1:N(2)
% the degree is i-1
    Hx(i,:) = (xxx.*Hx(i-1,:)-sqrti1*Hx(i-2,:))/sqrti;
    sqrti1 = sqrti;
    sqrti = sqrt(i);					    
  end
end
if (nargout >= 2)
   N = N-1;
   Hxdx = [-Hx(2,:); (spdiags(sqrt([1:N(2)-1]'),0,N(2)-1,N(2)-1)*Hx(1:N(2)-1,:)-...
          spdiags(sqrt([2:N(2)]'),0,N(2)-1,N(2)-1)*Hx(3:N(2)+1,:))]/sqrt(2);
   varargout{1} = reshape(sum((Hy(1:N(1),:)'*psis).*Hxdx',2),size(xx));
end
if (nargout == 3)
   Hydy = [-Hy(2,:); (spdiags(sqrt([1:N(1)-1]'),0,N(1)-1,N(1)-1)*Hy(1:N(1)-1,:)-...
          spdiags(sqrt([2:N(1)]'),0,N(1)-1,N(1)-1)*Hy(3:N(1)+1,:))]/sqrt(2);
   varargout{2} = reshape(sum((Hydy'*psis).*Hx(1:N(2),:)',2),size(xx));
end
%z = reshape(sum((Hy(1:N,:)'*psis).*Hx(1:N,:)',2),size(xx));
z = Hy'*psis*Hx;
