function [R,varargout] = residual2dsys(N,NH,phis,phirw,contparams,Hw,ev,...
					   diffpotential,varargin)
% 2d system
% with 8 input parameters, the residual
% with 9 input parameters, the residual and the gradient of the 
% penalty function
l = length(phis)-1;
Hwx = Hw{1};
Hwy = Hw{2};
[phirw2{1:l}] = deal(zeros(size(phirw{1})));
% precompute squares
for i = 1:l
  phirw2{i} = phirw{i}.^2;
end
[R{1:l}] = deal(zeros(size(phis{1})));
R{l+1} = zeros(l,1);
for i = 1:l
  R{i} = (ev{i}-2*phis{l+1}(i)).*phis{i};
  temp = contparams{1}(i)*diffpotential{i};
  for j = 1:l
    temp = temp+contparams{2}(i,j)*phirw2{j};
  end
  R{i} = R{i}+2*reshape(Hwy*(temp.*phirw{i})*Hwx',NH(2)*NH(1),1);
  R{l+1}(i) = N(i)-norm(phis{i})^2;
end
if (nargin == 9)
  r = varargin{1};
  Rpenalty = zeros(l*NH(2)*NH(1),1);
  for i = 1:l
    Rpenalty((i-1)*NH(2)*NH(1)+1:i*NH(2)*NH(1)) = R{i}(:)+...
	2*(phis{l+1}(i)-r*sign(R{l+1}(i)))*phis{i};
  end
  varargout{1} = Rpenalty;
end