% Splitting - Scheme involving s-stages 
function psi_exp = timeintegration_2d_sys(method,dt,N,psi_exp,spectral);
[s,a,b] = methodcoefficients(method);

if (strcmp(spectral,'bounded'))
  pA = @partA_2d_fft_sys;
  pB = @partB_2d_fft_sys;
else
  pA = @partA_2d_sys;
  pB = @partB_2d_sys;
end
if method ~= 613
    % General splitting scheme of form
    % b(s)a(s)...b(1)a(1) b(s)a(s)...b(1)a(1)
    if abs(a(1)) > 0
        for n = 1:N
            for j = 1:s
                psi_exp = feval(pA,psi_exp,a(j)*dt);
                psi_exp = feval(pB,psi_exp,b(j)*dt);
            end
        end
        % number_expA = s*N;
    end
    % Splitting scheme with a(1) = 0
    % b(s) a(s)...b(2)a(2)(b(1)+b(s))...a(s)...b(2)a(2)b(1), c(1) = b(1)+b(s)
    if a(1) == 0
        c = b;
        c(1) = b(1)+b(s);
        for j = 1:s-1
            psi_exp = feval(pB,psi_exp,b(j)*dt);
            psi_exp = feval(pA,psi_exp,a(j+1)*dt);
        end
        for n = 1:N-1
            for j = 1:s-1
                psi_exp = feval(pB,psi_exp,c(j)*dt);
                psi_exp = feval(pA,psi_exp,a(j+1)*dt);
            end
            %    mesh(abs(psi_exp.*exp_xy).^2)
            %pause(0.01)
        end
        psi_exp = feval(pB,psi_exp,b(s)*dt);
        % number_expA = (s-1)*N;
    end
else
    c = b;
    c(1) = b(1)+b(s);
    for j = 1:s-1
        psi_exp = feval(pA,psi_exp,b(j)*dt);
        psi_exp = feval(pB,psi_exp,a(j+1)*dt);
    end
    for n = 1:N-1
        for j = 1:s-1
            psi_exp = feval(pA,psi_exp,c(j)*dt);
            psi_exp = feval(pB,psi_exp,a(j+1)*dt);
        end
        %    mesh(abs(psi_exp.*exp_xy).^2)
        %pause(0.01)
    end
    psi_exp = feval(pA,psi_exp,b(s)*dt);
    % number_expA = (s-1)*N;
end
